#!/bin/bash

#updates by WIPAT 2555-04-24
#updates by WIBOON 2557-06-23

if [ -z "$(id -nG|grep -w "root")" ] ; then
  echo "need root, or try: sudo sh $0"
  exit
fi

while true; do
    read -p "Confirm to start installation? (y/n)" yn
    case $yn in
        [Yy]* ) CONFIRM_INSTALL="yes"; break;;
        [Nn]* ) CONFIRM_INSTALL="no"; break;;
        * ) echo "Please answer y or n.";;
    esac
done
if [ "${CONFIRM_INSTALL}" = "no" ]; then
  exit 
fi

sudo apt-get update
sudo apt-get -y install apache2
sudo apt-get -y install php5 expect 
sudo apt-get -y install expect 
sudo apt-get -y install whois
sudo apt-get -y install apg

#check apache2 version
if [ -f "/etc/apache2/sites-available/default" ] ; then
  MYFILE="/etc/apache2/sites-available/default"
else
  if [ -f "/etc/apache2/sites-available/000-default.conf" ] ; then
    MYFILE="/etc/apache2/sites-available/000-default.conf"
  else
    echo "No apache2 default site config file"
    exit
  fi
fi
documentroot=$(grep DocumentRoot ${MYFILE} | cut -d' ' -f2)
#
MY_DIR=$(pwd)
DST_DIR="/"
if [ "${documentroot}" = "/var/www" ] ; then
  SRC_DIR="${MY_DIR}/trunk/"
fi
if [ "${documentroot}" = "/var/www/html" ] ; then
  SRC_DIR="${MY_DIR}/trunk1404/"
fi

# copy files in directory trunk or trunk1404
find ${SRC_DIR} -type d| while read LINE ; do
  TARGET=$(echo ${LINE}|sed "s;${SRC_DIR};${DST_DIR};")
  if [ ! -d "${TARGET}" ] ; then
    mkdir ${TARGET}
  fi
done
find ${SRC_DIR} -type f| while read LINE ; do
  TARGET=$(echo ${LINE}|sed "s;${SRC_DIR};${DST_DIR};")
  if [ -e "${TARGET}" ] ; then
    if [ -z "$(diff -q ${LINE} ${TARGET})" ] ; then
      continue
    fi 
    INFO=$(ls -clQ --time-style=long-iso ${TARGET})
    CTIME=$(echo ${INFO}|awk '{ print $6"-"$7 }')
    NAME=$(echo "${TARGET}_${CTIME}")
    cp -v ${TARGET} ${NAME}
  fi
  cp -v ${LINE} ${TARGET}
done
sudo cp -f ${MY_DIR}/version.txt /root/psu-netdrive.version

sudo groupadd sftponly 
sudo mkdir -p /sftp 
sudo mkdir -p /sftp/home
sudo chmod 0111 /sftp/home 
sudo mkdir -p /sftp/share 
sudo chmod +t /sftp/share 
sudo groupadd member
sudo mkdir -p /sftp/share/member 
sudo chgrp -Rv member /sftp/share/member
sudo chmod  g+rws,o-rwx /sftp/share/member 
sudo gpasswd -a $(grep "1000:.*/home" /etc/passwd | cut -d: -f1) member
sudo chmod +x ${documentroot}/myservice/check-shadow.sh 
sudo chmod +x ${documentroot}/myservice/change-passwd.exp 
MYSUDO="www-data ALL= NOPASSWD: ${documentroot}/myservice/check-shadow.sh, ${documentroot}/myservice/change-passwd.exp"
MYFILE="/etc/sudoers"
if [ -z "$(grep "${MYSUDO}" ${MYFILE})" ] ; then
  echo "${MYSUDO}" >> ${MYFILE}
fi 
#
sudo cp -f ${MY_DIR}/user_manual.txt /sftp/home/
sudo touch /sftp/home/DO_NOT_UPLOAD_HERE.txt
sudo mkdir -p ${documentroot}/hidename
sudo mkdir -p ${documentroot}/ishare
MYINSTALL="<Directory ${documentroot}/hidename/>"
if [ -f "/etc/apache2/sites-available/default" ] ; then
  MYFILE="/etc/apache2/sites-available/default"
else
  if [ -f "/etc/apache2/sites-available/000-default.conf" ] ; then
    MYFILE="/etc/apache2/sites-available/000-default.conf"
  else
    echo "No apache2 default site config file"
    exit
  fi
fi
if [ -z "$(grep "${MYINSTALL}" ${MYFILE})" ] ; then
  sudo sed -i "/^<\/VirtualHost>/i\	<Directory ${documentroot}/hidename/>\
\n                Options FollowSymLinks MultiViews\
\n                AllowOverride None\
\n                Order allow,deny\
\n                allow from all\
\n	</Directory>" ${MYFILE}
fi
sudo service apache2 restart

sudo sed -i '/^Subsystem sftp/s/^Subsystem sftp/#Subsystem sftp/g' /etc/ssh/sshd_config
(echo "
Subsystem sftp internal-sftp
Match Group sftponly
  ChrootDirectory /sftp
  ForceCommand internal-sftp -d home/%u") | sudo tee -a /etc/ssh/sshd_config
sudo reload ssh

if [ ! -z "$(grep "/home" /etc/fstab)" ]; then
   FOUND_FSTAB_HOME="yes"
else
   FOUND_FSTAB_HOME="no"
fi

if [ "${FOUND_FSTAB_HOME}" = "yes" ]; then
while true; do
    echo "Found! partition /home in /etc/fstab"
    echo "Do you wish to use /home or / for net-drive users? (y/n) "
    read -p "y=/home  n=/(default) :" yn
    case $yn in
        [Yy]* ) USE_HOME_PAR="yes"; break;;
        [Nn]* ) USE_HOME_PAR="no"; break;;
        * ) echo "Please answer y or n.";;
    esac
done
if [ "${USE_HOME_PAR}" = "yes" ]; then
    sudo sh move-sftp-to-home.sh
else
    echo "copy move-sftp-to-home.sh to /root for later use /home for net-drive users"
    sudo cp move-sftp-to-home.sh /root
fi
fi

echo "                "
echo "................"
echo "Next, option 1/4"
echo "To install anonymous ftp server (vsftpd) and make link to /sftp/ftp/pub."
while true; do
    echo "Do you wish to install anonymous ftp server? (y/n) "
    read -p "y=install now  n=you can install later :" yn
    case $yn in
        [Yy]* ) VSFTPD_INSTALL="yes"; break;;
        [Nn]* ) VSFTPD_INSTALL="no"; break;;
        * ) echo "Please answer y or n.";;
    esac
done
if [ "${VSFTPD_INSTALL}" = "yes" ]; then
    sudo sh install-psu-netdrive-2-anonymous.sh 
else
    echo "copy install-psu-netdrive-2-anonymous.sh to /root for later install"
    sudo cp install-psu-netdrive-2-anonymous.sh /root
fi

echo "                "
echo "................"
echo "Next, option 2/4"
echo "To install shorewall and fail2ban to protect from hacker."
echo "( shorewall default firewall interface is eth0 )"
echo "( fail2ban default protect your tcp port 22(ssh) )"
while true; do
    echo "Do you wish to install shorewall and fail2ban? (y/n) "
    read -p "y=install now  n=you can install later :" yn
    case $yn in
        [Yy]* ) SHOREWALL_INSTALL="yes"; break;;
        [Nn]* ) SHOREWALL_INSTALL="no"; break;;
        * ) echo "Please answer y or n.";;
    esac
done
if [ "${SHOREWALL_INSTALL}" = "yes" ]; then
    sudo sh install-shorewall-fail2ban.sh
else
    echo "copy install-shorewall-fail2ban.sh to /root for later install"
    sudo cp install-shorewall-fail2ban.sh /root
fi

echo "                "
echo "................"
echo "Next, option 3/4"
echo "To install disk quota system for PSU-netdrive's partition."
while true; do
    echo "Do you wish to install disk quota system? (y/n) "
    read -p "y=install now  n=you can install later :" yn
    case $yn in
        [Yy]* ) QUOTA_INSTALL="yes"; break;;
        [Nn]* ) QUOTA_INSTALL="no"; break;;
        * ) echo "Please answer y or n.";;
    esac
done
if [ "${QUOTA_INSTALL}" = "yes" ]; then
    sudo sh install-quota.sh
else
    echo "copy install-quota.sh to /root for later install"
    sudo cp install-quota.sh /root
fi

echo "                "
echo "................"
echo "Next, option 4/4"
echo "To install libpam-radius-auth library, then SFTP will also work with FreeRADIUS for your existing username database i.e. ldap or sql." 

while true; do
    echo "Do you wish to install libpam-radius-auth? (y/n) "
    read -p "y=install now  n=you can install later :" yn
    case $yn in
        [Yy]* ) LIBPAMRADIUS_INSTALL="yes"; break;;
        [Nn]* ) LIBPAMRADIUS_INSTALL="no"; break;;
        * ) echo "Please answer y or n.";;
    esac
done
if [ "${LIBPAMRADIUS_INSTALL}" = "yes" ]; then
    sudo sh install-pam-radius.sh
    if [ ! -f /etc/freeradius/clients.conf ] ; then
      echo "copy install-pam-radius.sh to /root for later install"
      sudo cp install-pam-radius.sh /root
    fi
else
    echo "copy install-pam-radius.sh to /root for later install"
    sudo cp install-pam-radius.sh /root
fi
echo "Finished."
