#!/bin/bash

# created by WIBOON 2556-04-13
# updated by WIBOON 2557-06-22

save_exist_file(){
  TARGET="$1"
  if [ -f ${TARGET} ]; then
      INFO=$(ls -clQ --time-style=long-iso ${TARGET})
      CTIME=$(echo ${INFO}|awk '{ print $6"-"$7 }')
      NAME=$(echo "${TARGET}_${CTIME}")
      sudo cp -v ${TARGET} ${NAME}
  fi
}

sudo apt-get -y install shorewall
save_exist_file "/etc/shorewall/zones"
sudo cp /usr/share/doc/shorewall/examples/one-interface/zones /etc/shorewall
save_exist_file "/etc/shorewall/interfaces"
sudo cp /usr/share/doc/shorewall/examples/one-interface/interfaces /etc/shorewall
save_exist_file "/etc/shorewall/policy"
sudo cp /usr/share/doc/shorewall/examples/one-interface/policy /etc/shorewall
save_exist_file "/etc/shorewall/rules"
sudo cp /usr/share/doc/shorewall/examples/one-interface/rules /etc/shorewall
sudo sed -i '/^startup/s/0/1/g' /etc/default/shorewall
sudo sed -i '/^Ping(DROP)/s/^Ping/#Ping/g' /etc/shorewall/rules
#--------------
(echo "DROP net:42.2.192.0/19 fw
DROP net:116.8.0.0/14 fw
DROP net:140.115.0.0/16 fw
DROP net:190.120.232.0/21 fw
DROP net:202.65.138.200/29 fw
DROP net:223.4.0.0/16 fw
DROP net:197.0.0.0/8 fw
DROP net:202.138.126.0/23 fw 
# default open all ports
ACCEPT all fw
# PING
#ACCEPT all fw icmp 8
# FTP
#ACCEPT all fw tcp 21
# SSH
#ACCEPT all fw tcp 22
# SMTP
#ACCEPT all fw tcp 25
# HTTP,HTTPS
#ACCEPT all fw tcp 80,443
# RSYNC
#ACCEPT all fw tcp 873
# STREAM
#ACCEPT all fw tcp 8080
# RADIUS
#ACCEPT all fw udp 1812,1813
# TRACEROUTE
#ACCEPT all fw udp 33434:33443
# Options
# NFSD,PORTMAP,STATD,LOCKD,MOUNTD
#ACCEPT net:192.168.5.0/24 fw tcp 111,2049
#ACCEPT net:192.168.5.0/24 fw udp 111,2049
#ACCEPT net:192.168.5.0/24 fw tcp 4000:4002
#ACCEPT net:192.168.5.0/24 fw udp 4000:4002
# Pykota
#ACCEPT net:192.168.5.0/24 fw tcp 7654
# TFTP
#ACCEPT net:192.168.5.0/24 fw udp 69
# UDPCAST
#ACCEPT net:192.168.5.0/24 fw udp 9000,9001
# DNS
#ACCEPT net:192.168.5.0/24 fw udp 53
# DHCPD
#ACCEPT net:192.168.5.0/24 fw udp 67:68") | sudo tee -a /etc/shorewall/rules

#---------------------
sudo apt-get -y install fail2ban
sudo service fail2ban start
sudo sed -i 's/640/644/g' /etc/logrotate.d/fail2ban
sudo chmod o+r /var/log/fail2ban.log
sudo chmod o+r /var/log/auth.log
#check apache2 version
if [ -f "/etc/apache2/sites-available/default" ] ; then
  MYFILE="/etc/apache2/sites-available/default"
else
  if [ -f "/etc/apache2/sites-available/000-default.conf" ] ; then
    MYFILE="/etc/apache2/sites-available/000-default.conf"
  else
    echo "No apache2 default site config file"
    exit
  fi
fi
documentroot=$(grep DocumentRoot ${MYFILE} | cut -d' ' -f2)
#
dir1=${documentroot}/logfail2ban
if [ ! -d ${dir1} ]; then
    sudo mkdir -p ${dir1} 
fi
#------------------------
(echo "<?php
echo '<pre>';
system('egrep \"Ban|Unban\" /var/log/fail2ban.log');
echo '</pre>';
?>") | sudo tee $dir1/logfail2ban.php 
#------------------------
(echo "<?php
echo '<pre>';
system('grep Failed /var/log/auth.log > /tmp/\$$; grep -o \"^.*for\" /tmp/\$$ > /tmp/left\$$; grep -o \"from.*$\" /tmp/\$$ > /tmp/right\$$; paste /tmp/left\$$ /tmp/right\$$ ; rm /tmp/*\$$*');
echo '</pre>';
?>") | sudo tee $dir1/logauth.php
#------------------------
echo ""
sudo service shorewall start
echo ""
echo "REMARK"
echo "My shorewall default interface is eth0"
echo "My shorewall default open all ports. (/etc/shorewall/rules)"
echo "My fail2ban default monitor tcp(22:SSH). (/etc/fail2ban/jail.conf)"

