#!/bin/bash

# updated by WIBOON 2556-04-17

checkinput() 
{ 
  echo $1 | grep -Eq '^(\+|-)?[0-9]+$'
  return $?
}

exitusage()
{
  echo "usage: sudo sh $0 username"
  echo "       use default diskquota: 5120000 (1GB = 1024000)"
  echo "       or"
  echo "       sudo sh $0 username diskquota"
  exit
}

if [ -z "$(id -nG|grep -w "root")" ] ; then
  echo "need root, or try: sudo sh $0"
  exit
fi
if [ "$1" = "--help" ] ; then
  exitusage
fi
if [ -z "$1" ] ; then
  echo "need username"
  exit 
fi
if [ -z "$(getent passwd $1)" ] ; then
  echo "username $1 does not exist"
  exit
fi
MYUSER=$1
if [ -z "$2" ] ; then
  Q_HDD=5120000
else
  checkinput $2 || exitusage && Q_HDD=$2
fi
if [ -z "$(grep usrquota /etc/fstab)" ] ; then
  echo "Disk quota system is not install. This required additional steps already set up."
  echo "User disk quota is not set yet."
else
  # 2048000=2GB, 5120000=5GB, 20480000=20GB
  SHOWQ_HDD=$(( ${Q_HDD} / 1024000 ))
  echo "Setting user disk quota limit: ${Q_HDD} ($SHOWQ_HDD GB)."
  sudo setquota -u ${MYUSER} 0 ${Q_HDD} 0 0 -a
  echo "Current disk quota ${MYUSER}:"
  sudo repquota -sa | egrep "Space limits|User|-----|${MYUSER}"
  echo "To view all users quota: sudo repquota -sa"
fi
